"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  withForwardedNavigationParams: true,
  forwardNavigationParams: true
};
exports.forwardNavigationParams = forwardNavigationParams;
exports.withForwardedNavigationParams = withForwardedNavigationParams;

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _types = require("./types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _types[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function withForwardedNavigationParams(SecondOrderWrapperComponent) {
  return function (WrappedComponent) {
    const TargetWithHoistedStatics = forwardNavigationParams(SecondOrderWrapperComponent)(WrappedComponent);
    return TargetWithHoistedStatics;
  };
}

function forwardNavigationParams(SecondOrderWrapperComponent) {
  return function (WrappedComponent) {
    const TargetComponent = props => {
      const params = (props === null || props === void 0 ? void 0 : props.route) && props.route.params;

      if (!SecondOrderWrapperComponent) {
        return /*#__PURE__*/_react.default.createElement(WrappedComponent, _extends({}, props, params));
      } else {
        return /*#__PURE__*/_react.default.createElement(SecondOrderWrapperComponent, _extends({
          WrappedComponent: WrappedComponent
        }, props, params));
      }
    };

    TargetComponent.displayName = `withForwardedNavigationParams(${WrappedComponent.displayName || WrappedComponent.name})`;
    (0, _hoistNonReactStatics.default)(TargetComponent, WrappedComponent);
    TargetComponent.wrappedComponent = WrappedComponent;
    return TargetComponent;
  };
}
//# sourceMappingURL=index.js.map