function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import hoistNonReactStatics from 'hoist-non-react-statics';
export * from './types';
export function withForwardedNavigationParams(SecondOrderWrapperComponent) {
  return function (WrappedComponent) {
    const TargetWithHoistedStatics = forwardNavigationParams(SecondOrderWrapperComponent)(WrappedComponent);
    return TargetWithHoistedStatics;
  };
}
export function forwardNavigationParams(SecondOrderWrapperComponent) {
  return function (WrappedComponent) {
    const TargetComponent = props => {
      const params = (props === null || props === void 0 ? void 0 : props.route) && props.route.params;

      if (!SecondOrderWrapperComponent) {
        return /*#__PURE__*/React.createElement(WrappedComponent, _extends({}, props, params));
      } else {
        return /*#__PURE__*/React.createElement(SecondOrderWrapperComponent, _extends({
          WrappedComponent: WrappedComponent
        }, props, params));
      }
    };

    TargetComponent.displayName = `withForwardedNavigationParams(${WrappedComponent.displayName || WrappedComponent.name})`;
    hoistNonReactStatics(TargetComponent, WrappedComponent);
    TargetComponent.wrappedComponent = WrappedComponent;
    return TargetComponent;
  };
}
//# sourceMappingURL=index.js.map