import type { NativeStackScreenProps } from '@react-navigation/native-stack';
import type { BottomTabScreenProps } from '@react-navigation/bottom-tabs';
import type { ComponentType } from 'react';
import type { ParamListBase, RouteProp } from '@react-navigation/core';
import type { StackScreenProps } from '@react-navigation/stack';
import type { DrawerScreenProps } from '@react-navigation/drawer';
export declare type ScreenPropsSource<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = DrawerScreenProps<ParamList, RouteName> | BottomTabScreenProps<ParamList, RouteName> | NativeStackScreenProps<ParamList, RouteName> | StackScreenProps<ParamList, RouteName>;
declare const paramListKey = "";
export declare type ParamListKeyType = typeof paramListKey;
export declare type ScreenPropsWithForwardedNavParams<ScreenProps extends ScreenPropsSource<ParamList, RouteName>, ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = Omit<{
    [K in keyof RouteProp<ParamList, RouteName>['params']]: RouteProp<ParamList, RouteName>['params'][K];
}, 'navigation' | 'route' | ParamListKeyType> & ScreenProps & {
    [paramListKey]: ParamList;
};
export declare type ForwardedNativeStackScreenProps<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = ScreenPropsWithForwardedNavParams<NativeStackScreenProps<ParamList, RouteName>, ParamList, RouteName>;
export declare type ForwardedStackScreenProps<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = ScreenPropsWithForwardedNavParams<StackScreenProps<ParamList, RouteName>, ParamList, RouteName>;
export declare type ForwardedDrawerScreenProps<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = ScreenPropsWithForwardedNavParams<DrawerScreenProps<ParamList, RouteName>, ParamList, RouteName>;
export declare type ForwardedTabScreenProps<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = ScreenPropsWithForwardedNavParams<BottomTabScreenProps<ParamList, RouteName>, ParamList, RouteName>;
export declare type ForwardedScreenProps<ParamList extends ParamListBase, RouteName extends keyof ParamList = string> = ForwardedNativeStackScreenProps<ParamList, RouteName> | ForwardedDrawerScreenProps<ParamList, RouteName> | ForwardedTabScreenProps<ParamList, RouteName> | ForwardedStackScreenProps<ParamList, RouteName>;
declare type OmitParamList<ScreenProps> = Omit<ScreenProps, ParamListKeyType>;
export declare type NavigationAndRoute<ScreenProps extends ScreenPropsSource<any, any>> = Pick<ScreenProps, 'navigation' | 'route'>;
export declare type WithForwardedNavigationParamsReturn<ScreenProps extends ScreenPropsSource<any, any>> = (WrappedComponent: ComponentType<ScreenProps>) => ComponentType<NavigationAndRoute<ScreenProps>> & {
    wrappedComponent: ComponentType<ScreenProps>;
};
export declare type SecondOrderWrapperType<ScreenProps extends ForwardedScreenProps<any, any>> = ComponentType<OmitParamList<ScreenProps> & {
    WrappedComponent: ComponentType<OmitParamList<ScreenProps>>;
}>;
export {};
